<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Meal Management</title>
</head>
<body>

    <h1>Meal Management</h1>

    <!-- Form to create a new meal -->
    <h2>Create New Meal</h2>
    <form id="createMealForm">
        <label for="name">Name:</label>
        <input type="text" id="name" name="name" required>

        <label for="price">Price:</label>
        <input type="number" id="price" name="price" required>

        <label for="imageUrl">Image URL:</label>
        <input type="text" id="imageUrl" name="imageUrl" required>

        <button type="button" onclick="createMeal()">Create Meal</button>
    </form>

    <!-- Table to display all meals -->
    <h2>All Meals</h2>
    <table border="1">
        <thead>
            <tr>
                <th>ID</th>
                <th>Name</th>
                <th>Price</th>
                <th>Image URL</th>
                <th>Edit</th>
                <th>Delete</th>
            </tr>
        </thead>
        <tbody id="mealTableBody">
            <!-- Meal data will be loaded here -->
        </tbody>
    </table>

    <script>
        const apiUrl = 'http://localhost:8090/api/v1/meals';

        // Function to fetch and display all meals
        function getAllMeals() {
            fetch(apiUrl)
                .then(response => response.json())
                .then(data => {
                    const mealTableBody = document.getElementById('mealTableBody');
                    mealTableBody.innerHTML = ''; // Clear existing table rows

                    data.forEach(meal => {
                        // Create a table row for each meal
                        const row = document.createElement('tr');

                        // Populate table cells with meal data
                        const cells = [
                            meal.id,
                            meal.name,
                            meal.price,
                            meal.imageUrl,
                            `<button onclick="editMeal(${meal.id})">Edit</button>`,
                            `<button onclick="deleteMeal(${meal.id})">Delete</button>`
                        ];

                        cells.forEach(cellData => {
                            const cell = document.createElement('td');
                            cell.innerHTML = cellData;
                            row.appendChild(cell);
                        });

                        // Append the row to the table body
                        mealTableBody.appendChild(row);
                    });
                })
                .catch(error => {
                    console.error('Error fetching meal information:', error);
                });
        }

        // Function to create a new meal
        function createMeal() {
            const createMealForm = document.getElementById('createMealForm');
            const formData = new FormData(createMealForm);

            fetch(apiUrl, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                    name: formData.get('name'),
                    price: formData.get('price'),
                    imageUrl: formData.get('imageUrl'),
                }),
            })
            .then(response => response.json())
            .then(data => {
                console.log('Meal created successfully:', data);
                // Refresh the table with updated data
                getAllMeals();
            })
            .catch(error => {
                console.error('Error creating meal:', error);
            });
        }

        // Function to edit a meal
        function editMeal(mealId) {
            // Implement the logic to fetch the specific meal by ID and populate the edit form
            fetch(`${apiUrl}/${mealId}`)
                .then(response => response.json())
                .then(data => {
                    // Populate the edit form with the retrieved data
                    document.getElementById('name').value = data.name;
                    document.getElementById('price').value = data.price;
                    document.getElementById('imageUrl').value = data.imageUrl;
                })
                .catch(error => {
                    console.error('Error fetching meal information for editing:', error);
                });
        }

        // Function to delete a meal
        function deleteMeal(mealId) {
            fetch(`${apiUrl}/${mealId}`, {
                method: 'DELETE',
            })
            .then(response => {
                if (response.ok) {
                    console.log('Meal deleted successfully');
                    // Refresh the table with updated data
                    getAllMeals();
                } else {
                    console.error('Error deleting meal');
                }
            })
            .catch(error => {
                console.error('Error deleting meal:', error);
            });
        }

        // Call the getAllMeals function when the page loads
        window.onload = getAllMeals;
    </script>

</body>
</html>
